stages:
  - test
  - build
  - deploy

realizar_testes:
  stage: test
  image: node:17-alpine3.14
  tags:
    - notebook
  before_script:
    - cd app/
    - npm install 
  script:
    - npm test
  artifacts:
    when: always
    reports:
      junit: app/junit.xml

build_images:
  stage: build
  tags:
    - notebook
  needs: 
    - realizar_testes
  image: docker:20.10.16
  services:
    - docker:20.10.16-dind
  variables:
    DOCKER_TLS_CERTDIR: "/certs"
  before_script:
    - docker login -u $REGISTRY_USER -p $REGISTRY_PASS
  script:
    - docker build -t fabiolapa723/gitlab-cicd-app:1.0 .
    - docker push fabiolapa723/gitlab-cicd-app:1.0

deploy_dev:
  stage: deploy
  needs: 
    - build_images
  tags:
    - notebook
  script:
    - docker stop nodeapp
    - docker run -d --rm --name nodeapp -p 3000:3000 fabiolapa723/gitlab-cicd-app:1.0
  
